#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pcpdir.h"
#include "pcplus.h"

char PCPDir [] = PCPDIR;

struct PcLocRec PcLoc;
struct PcAddrRec PcAddr;
struct PcSearchRec PcSearch;

/* get a line of input from the keyboard. Change the line feed to a NUL */
/* Use fgets rather than gets because gets is unsafe */
char * getLine(char *d, size_t len){
	char *p;
	fgets(d,len,stdin);
	p = strchr(d,'\n');
   if (p)
		*p = '\0';
   return d;
}

/* Strip trailing spaces from the string s of length c */
size_t Rtrim(char *s, size_t c){
   int i;
   for (i = c - 1; i >= 0; i--)
      if ( s[i] == ' ' ) s[i] = '\0';		/* strip trailing spaces */
      else break;
   return (i + 1);
}

/* We must null terminate the source string, but there may not be sufficient
	space to do so at the end of the source string, so we must copy to a
	temporary string first */
void Show(char *l, char *s,short int c){
   char *t = malloc (c + 1);              /* get temp */
   printf("%s",l);								/* show the legend */
   strncpy(t,s,c);								/* copy to temp */
   t[c] = '\0';									/* null terminate */
   Rtrim(t,c);										/* strip spaces */
   printf("%s\n",t); 		 					/* show result */
   free(t);											/* free temp */
}
#define SHOWPC(x,y) Show(x,PcLoc.y,sizeof(PcLoc.y))
#define SHOWADDR(x,y) Show(x,PcAddr.y,sizeof(PcAddr.y))

int main(){
   char input[256];
   long sectors, matches;
   int postcodes, addresses, breaks;
   int searchType = 0;
   int skip = 0;
   sprintf(PcLoc.VLI,"%04d",(int)sizeof(struct PcLocRec));
   sprintf(PcAddr.VLI,"%04d",(int)sizeof(struct PcAddrRec));
   sprintf(PcSearch.VLI,"%04d",(int)sizeof(struct PcSearchRec));

	while (1){
      addresses = 0;
      breaks = 0;
      postcodes = 0;
      printf("Search type - %d (s to change)\n",searchType);
      printf("Enter start outcode (z when done, r to repeat): ");
      getLine(input,sizeof(input));
      if (strcmp(input,"z") == 0)
         break;
      if (strcmp(input,"r") == 0)
         goto search;
      if (strcmp(input,"s") == 0){
         searchType = searchType + 1;
         if (searchType > 2) searchType = 0;
         goto quit;
      }
      strcpy(PcSearch.PcFrom,input);
      printf("Enter end outcode: ");
      getLine(input,sizeof(input));
      if (strcmp(input,"z") == 0)
         break;
      strcpy(PcSearch.PcTo,input);

      printf("Enter Org: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.Org,input);

      printf("Enter Building: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.Building,input);

      printf("Enter Street: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.Street,input);

      printf("Enter Locality: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.DepLoc,input);

      printf("Enter Town: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.Town,input);

      printf("Enter County: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.County,input);

      printf("Enter STD code: ");
      getLine(input,sizeof(input));
      strcpy(PcSearch.STDCode,input);

search:
      if ((sectors = InitiateSearch(&PcSearch, searchType)) < 0){
         printf("Not found");
      } else {
         printf("Searching %d sectors ...\n",(int)sectors);
         while ((matches = GetMatch(&PcLoc,skip)) >= 0){
            char temp[10];
            int dPts, i;

/*            if (PcLoc.County[0] != ' ')*/
/*            	continue;*/
redo:
				if (matches == 0){
					breaks++;
					continue;
				}
            postcodes++;
            skip = 0;
            SHOWPC("Postcode        : ",Postcode);
            SHOWPC("Dep Street      : ",DepStreet);
            SHOWPC("Street          : ",Street);
            SHOWPC("Dep Locality    : ",DepLoc);
            SHOWPC("Dbl Dep Loc     : ",DblDepLoc);
            SHOWPC("Town            : ",Town);
            printf("County Source   : %c\r\n",PcLoc.CountySource);
            SHOWPC("County          : ",County);
            SHOWPC("County Abbr     : ",CountyAbbr);
            SHOWPC("Mailsort Code   : ",Mailsort);
            SHOWPC("STDCode         : ",STDCode);
            SHOWPC("GridE           : ",GridE);
            SHOWPC("GridN           : ",GridN);
            SHOWPC("Ward Code       : ",WardCode9);
            SHOWPC("Ward Name       : ",WardName);
            SHOWPC("SHA Code        : ",SHACode);
            SHOWPC("SHA Name        : ",NHSName);
            SHOWPC("NHS Reg. Code   : ",NHSRegionCode);
            SHOWPC("NHS Region      : ",NHSRegion);
            SHOWPC("Delivery Pts    : ",DeliveryPoints);
            printf("Postcode Type   : %c\r\n",PcLoc.UserType);
            SHOWPC("Constit. Code   : ",ConstituencyCode9);
            SHOWPC("Constituency    : ",Constituency);
            SHOWPC("Dev. Cons. Code : ",DCCCode);
            SHOWPC("Devolved Cons.  : ",DCCName);
            SHOWPC("TV Region       : ",TVRegion);
            SHOWPC("Authority Code  : ",AuthorityCode9);
            SHOWPC("Authority       : ",Laua);
            SHOWPC("Trad. County    : ",TradCounty);
            SHOWPC("Admin. County   : ",AdminCounty);
            SHOWPC("Censation       : ",CensusCode);
            SHOWPC("Cens. Label     : ",CensationLabel);
            SHOWPC("Affluence       : ",Affluence);
            SHOWPC("LifeStage       : ",LifeStage);
            SHOWPC("Additional      : ",AdditionalCensusInfo);
            printf("Occupancy       : %c\r\n",PcLoc.OccupancyType);
            printf("Address Type    : %c\r\n",PcLoc.AddressType);
            SHOWPC("PCT Code        : ",PCTCode9);
            SHOWPC("PCT Name        : ",PCTName);
            SHOWPC("EER Code        : ",EERCode9);
            SHOWPC("EER Name        : ",EERName);
            SHOWPC("Urban Rural     : ",UrbanRuralCode);
            SHOWPC("Urb. Rur. Name  : ",UrbanRuralName);
            SHOWPC("LEA Code        : ",LEACode);
            SHOWPC("LEA Name        : ",LEAName);
            SHOWPC("Latitute        : ",Latitude);
            SHOWPC("Longitude       : ",Longitude);
            SHOWPC("SOA Lower       : ",SOALower);
            SHOWPC("SOA Middle      : ",SOAMiddle);
            SHOWPC("Sub Country     : ",SubCountryName);
            printf("\r\n");
            strncpy(temp,PcLoc.DeliveryPoints,sizeof(PcLoc.DeliveryPoints));
            temp[sizeof(PcLoc.DeliveryPoints)] = '\0';
            dPts = atoi(temp);
            for (i = 1; i <= dPts; i++){
               if (GetAddress(&PcAddr,i) == 0)
                  continue;
               addresses++;
               SHOWADDR("Org         : ",Organisation);
               SHOWADDR("Dep         : ",Department);
               SHOWADDR("Number      : ",Number);
               SHOWADDR("Building    : ",Building);
               SHOWADDR("Subbuilding : ",SubBuilding);
               SHOWADDR("PO Box      : ",POBox);
               SHOWADDR("Households  : ",Households);
               SHOWADDR("DPS         : ",Mailcode);
               SHOWADDR("UDPRN       : ",Udprn);
               SHOWADDR("Just Built  : ",JustBuilt);
	       printf("\r\n");
               printf("R - Redo search, N - Next postcode, Q - Quit, S - Start search again, CR to continue: ");
			      getLine(input,sizeof(input));
               switch (input[0]){
               case 'n':
                  goto next;
               case 'q':
                  goto quit;
               case 'r':
                  goto redo;
               case 's':
                  goto search;
               case '+':
               if (skip == 0)
                     skip = 1;
                 else
                  skip = 0;
                  goto next;
               }
				}
next:
	;
			}
      }
quit:
		printf("Sectors %d, Postcodes %d, Addresses %d, Breaks %d\r\n",(int)sectors,postcodes,addresses,breaks);
	}
	return 0;
}

