#ifndef strutil_h
#define strutil_h
#include <stddef.h>

#ifndef BOOL_DEFINED
#define BOOL_DEFINED
typedef int BOOL;
#endif
#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif


#ifdef CTYPE_DEFS_REQUIRED
#ifdef isupper
#undef isupper
#undef islower
#undef isalpha
#undef isdigit
#undef toupper
#undef tolower
#endif
int isupper( int c );
int islower( int c );
int isalpha( int c );
int isdigit( int c);
int tolower(int c);
int toupper(int c);
#else
#include <ctype.h>
#endif

/*
#define bool BOOL
#define false FALSE
#define true TRUE
*/
char * LTrim(char * const s);
char * RTrim(char * const s);
char * Trim(char * const s);
char * Pad(char * const s, size_t sz);
char * ToUpper(char * const s);
char * ToLower(char * const s);
char * GetFirstWord(char * first, char * rest, const char * str);
char * GetLastWord(char * last, char * rest, const char * str);
char * SplitFields(char * first, char * rest, char *str);
char * Capitalise(char *s, size_t size);
char * RemoveLeadingNumber(char *r);
char * GetTrailingNumber(char * num, char * rest, const char * str);
void Cleanup(char *r);
char * RemoveSpaces(char *s);
char * RemoveExtraSpaces(char *s);
char * RemoveNonPrintable(char *r);
char * RemovePunctuation(char *r);
void RemoveNonWildcardPunctuation(char *r);
int compareCharacters(char *a, char *b);
int compareApprox (char *a, char *b);
char * recode ( char  * s, char inc);
char * undoReplaceSameLeadingCharsWithAlphabetic(char *thisLine, char *lastLine);
char * replaceSameLeadingCharsWithAlphabetic(char *thisLine, char *lastLine);
char * undoReplaceSameLeadingCharsWithChar(char *thisLine, char *lastLine);
char * replaceSameLeadingCharsWithChar(char *thisLine, char *lastLine);

char *compressLine(char *thisLine, char *lastLine);
char * uncompressLine(char *thisLine, char *lastLine);
long getSignature(char *s);
char *  decodeSignature(long sig, char * tranStr);
int GetSTDCode(char *number, char *std);
BOOL encode(char *dest, const char * source);
BOOL decode(char *dest, const char * source);

#define TRAN_A 1
#define TRAN_B 2
#define TRAN_C (2 << 1)
#define TRAN_D (2 << 2)
#define TRAN_E (2 << 3)
#define TRAN_F (2 << 4)
#define TRAN_G (2 << 5)
#define TRAN_H (2 << 6)
#define TRAN_I (2 << 7)
#define TRAN_J (2 << 8)
#define TRAN_K (2 << 9)
#define TRAN_L (2 << 10)
#define TRAN_M (2 << 11)
#define TRAN_N (2 << 12)
#define TRAN_O (2 << 13)
#define TRAN_P (2 << 14)
#define TRAN_Q (2 << 15)
#define TRAN_R (2 << 16)
#define TRAN_S (2 << 17)
#define TRAN_T (2 << 18)
#define TRAN_U (2 << 19)
#define TRAN_V (2 << 20)
#define TRAN_W (2 << 21)
#define TRAN_X (2 << 22)
#define TRAN_Y (2 << 23)
#define TRAN_Z (2 << 24)
#define TRAN_SPACE (2 << 25)
#define TRAN_DIGIT (2 << 26)
#define TRAN_PUNCTUATION (2 << 28)
#define TRAN_INVALID (2 << 29)

#endif
